      SUBROUTINE MNRU3(N,DK,PK,QK,G,G1,EPS,IERR)                        MNRU0010
C      -----------------------------------------------------            MNRU0020
C     BCEHE MATP DK B METOE BOHA-ETEPA-AYA          MNRU0030
C      -----------------------------------------------------            MNRU0040
         INTEGER IERR,N                                                 MNRU0050
         REAL DK,EPS,G,G1,PK,QK                                         MNRU0060
         DIMENSION DK(N,N),G(N),G1(N),PK(N),QK(N)                       MNRU0070
         REAL ABS                                                       MNRU0080
         INTEGER I,J                                                    MNRU0090
         REAL PQ,S,S1                                                   MNRU0100
       IERR = 0                                                         MNRU0110
       PQ = 0.                                                          MNRU0120
       DO 10 I = 1, N                                                   MNRU0130
          QK(I) = G1(I) - G(I)                                          MNRU0140
          PQ = PK(I)*QK(I) + PQ                                         MNRU0150
   10  CONTINUE                                                         MNRU0160
       IF (ABS(PQ) .LT. EPS) GO TO 60                                   MNRU0170
          S = 0.                                                        MNRU0180
          DO 30 J = 1, N                                                MNRU0190
             S1 = 0.                                                    MNRU0200
             DO 20 I = 1, N                                             MNRU0210
                S1 = S1 + QK(I)*DK(I,J)                                 MNRU0220
   20        CONTINUE                                                   MNRU0230
             S = S + S1*QK(J)                                           MNRU0240
             G(J) = S1                                                  MNRU0250
   30     CONTINUE                                                      MNRU0260
          DO 50 I = 1, N                                                MNRU0270
             DO 40 J = 1, N                                             MNRU0280
                DK(I,J) = DK(I,J) + PK(I)*PK(J)/PQ - G(I)*G(J)/S        MNRU0290
   40        CONTINUE                                                   MNRU0300
   50     CONTINUE                                                      MNRU0310
          GO TO 70                                                      MNRU0320
   60  CONTINUE                                                         MNRU0330
       IERR = 1                                                         MNRU0340
   70  RETURN                                                           MNRU0350
      END                                                               MNRU0360
